"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WidgetCode = void 0;

var _react = _interopRequireDefault(require("react"));

var _uiSchema = require("@ui-schema/ui-schema");

var _CodeBar = require("@ui-schema/material-code/CodeBar");

var _Box = _interopRequireDefault(require("@mui/material/Box"));

var _FormLabel = _interopRequireDefault(require("@mui/material/FormLabel"));

var _LocaleHelperText = require("@ui-schema/ds-material/Component/LocaleHelperText");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var WidgetCode = function WidgetCode(_ref) {
  var storeKeys = _ref.storeKeys,
      schema = _ref.schema,
      value = _ref.value,
      onChange = _ref.onChange,
      valid = _ref.valid,
      required = _ref.required,
      errors = _ref.errors,
      showValidity = _ref.showValidity,
      readOnlyProp = _ref.readOnly,
      CodeMirror = _ref.CodeMirror,
      extensions = _ref.extensions,
      barBegin = _ref.barBegin,
      barContent = _ref.barContent,
      barEnd = _ref.barEnd,
      formatValue = _ref.formatValue,
      CustomCodeBar = _ref.CodeBar;

  var handleOnChange = _react["default"].useCallback(function (v, newValue) {
    if (!v.docChanged || typeof newValue !== 'string') {
      return;
    }

    onChange({
      storeKeys: storeKeys,
      scopes: ['value'],
      type: 'set',
      data: {
        value: newValue
      },
      schema: schema,
      required: required
    });
  }, [onChange, storeKeys, schema, required]);

  var hideTitle = schema === null || schema === void 0 ? void 0 : schema.getIn(['view', 'hideTitle']);
  var readOnly = readOnlyProp || (schema === null || schema === void 0 ? void 0 : schema.get('readOnly'));

  var classNamesContent = _react["default"].useMemo(function () {
    return valid ? undefined : ['invalid'];
  }, [valid]);

  var CodeBarComp = CustomCodeBar || _CodeBar.CodeBar;
  return _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(_Box["default"], {
    mb: 0.5
  }, _react["default"].createElement(_FormLabel["default"], {
    error: !valid && showValidity
  }, hideTitle ? null : _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(_uiSchema.TransTitle, {
    storeKeys: storeKeys,
    schema: schema
  }), required ? ' *' : null), formatValue ? _react["default"].createElement(_react["default"].Fragment, null, hideTitle ? null : ' (', _react["default"].createElement(_uiSchema.Trans, {
    text: 'formats.' + formatValue,
    fallback: formatValue
  }), hideTitle ? null : ')') : null)), _react["default"].createElement(CodeMirror, {
    value: value || '',
    onChange: readOnly ? undefined : handleOnChange,
    extensions: extensions,
    classNamesContent: classNamesContent,
    dense: schema.getIn(['view', 'dense'])
  }), _react["default"].createElement(_LocaleHelperText.ValidityHelperText, {
    errors: errors,
    showValidity: showValidity,
    schema: schema
  }), _react["default"].createElement(CodeBarComp, {
    schema: schema,
    barBegin: barBegin,
    barContent: barContent,
    barEnd: barEnd
  }));
};

exports.WidgetCode = WidgetCode;