"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useHighlightStyle = void 0;

var _react = _interopRequireDefault(require("react"));

var _highlight = require("@lezer/highlight");

var _language = require("@codemirror/language");

var _useTheme2 = _interopRequireDefault(require("@mui/material/styles/useTheme"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var useHighlightStyle = function useHighlightStyle() {
  var _useTheme = (0, _useTheme2["default"])(),
      palette = _useTheme.palette;

  return _react["default"].useMemo(function () {
    return _language.HighlightStyle.define([{
      tag: _highlight.tags.link,
      textDecoration: 'underline'
    }, {
      tag: _highlight.tags.heading,
      textDecoration: 'underline',
      fontWeight: 'bold'
    }, {
      tag: _highlight.tags.meta,
      color: palette.mode === 'dark' ? '#43978b' : '#2a719b'
    }, {
      tag: _highlight.tags.emphasis,
      fontStyle: 'italic'
    }, {
      tag: _highlight.tags.strong,
      fontWeight: 'bold'
    }, {
      tag: _highlight.tags.strikethrough,
      textDecoration: 'line-through'
    }, {
      tag: _highlight.tags.keyword,
      color: palette.mode === 'dark' ? '#f746ec' : '#8e0b99'
    }, {
      tag: [_highlight.tags.atom, _highlight.tags.bool, _highlight.tags.url, _highlight.tags.contentSeparator, _highlight.tags.labelName],
      color: palette.mode === 'dark' ? '#978ed3' : '#121cb1'
    }, {
      tag: [_highlight.tags.literal, _highlight.tags.inserted],
      color: palette.mode === 'dark' ? '#2da273' : '#116644'
    }, {
      tag: [_highlight.tags.deleted],
      color: palette.mode === 'dark' ? '#d22c2c' : '#aa1111'
    }, {
      tag: [_highlight.tags.brace],
      color: palette.text.secondary
    }, {
      tag: [_highlight.tags.bracket],
      color: palette.mode === 'dark' ? '#4b88d7' : '#0d64d5'
    }, {
      tag: [_highlight.tags.string],
      color: palette.mode === 'dark' ? '#83ca69' : '#08822c'
    }, {
      tag: [_highlight.tags.regexp, _highlight.tags.escape, _highlight.tags.special(_highlight.tags.string)],
      color: '#ee4400'
    }, {
      tag: _highlight.tags.definition(_highlight.tags.variableName),
      color: palette.mode === 'dark' ? '#5279ec' : '#255fb9'
    }, {
      tag: _highlight.tags.local(_highlight.tags.variableName),
      color: '#3300aa'
    }, {
      tag: [_highlight.tags.typeName, _highlight.tags.namespace],
      color: palette.mode === 'dark' ? '#ec4837' : '#b7382b'
    }, {
      tag: _highlight.tags.className,
      color: '#116677'
    }, {
      tag: [_highlight.tags.special(_highlight.tags.variableName), _highlight.tags.macroName],
      color: '#225566'
    }, {
      tag: _highlight.tags.definition(_highlight.tags.propertyName),
      color: '#0000cc'
    }, {
      tag: _highlight.tags.comment,
      color: palette.mode === 'dark' ? '#738284' : '#6b7677'
    }, {
      tag: _highlight.tags.invalid,
      color: '#ff0000'
    }]);
  }, [palette]);
};

exports.useHighlightStyle = useHighlightStyle;